算法训练day50卡玛70. 爬楼梯(进阶版)Leetcode322. 零钱兑换279. 完全平方数

57. 爬楼梯(第八期模拟笔试)

题目分析

我们可以使用动态规划。动态规划的思想是用一个数组dp来保存到达每一级台阶的方法数。对于每一级台阶i,你可以从i-1, i-2, ..., i-m级台阶爬上来(只要这些台阶的索引大于等于0),因此到达第i级台阶的方法数就是这些dp[j](i-m <= j < i)的总和。

acm代码模式

cpp 复制代码
#include <iostream>
#include <vector> 

int main() {
    int n, m;
    std::cin >> n >> m;
    std::vector<int> dp(n + 1, 0);
    dp[0] = 1;
    
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if(i - j >= 0) dp[i] += dp[i -j];   
        }
    }
    
    // for (int i : dp) std::cout << i << " ";
    std::cout << dp[n] << std::endl;
    return 0;
}

322. 零钱兑换

题目分析

本题是要求最少硬币数量,硬币是组合数还是排列数都无所谓!所以两个for循环先后顺序怎样都可以!

acm模式代码

cpp 复制代码
#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>

class Solution {
public:
    int coinChange(std::vector<int>& coins, int amount) {
        std::vector<int> dp(amount + 1, INT_MAX);
        dp[0] = 0;
        for (int i = 1; i <= amount; i ++) {
            for (int j = 0; j < coins.size(); j ++) {
                if (i >= coins[j] && dp[i - coins[j]] != INT_MAX) dp[i] = std::min(dp[i - coins[j]] + 1, dp[i]);
            }
        }
        if (dp[amount] == INT_MAX) return -1;
        for (int i: dp) std::cout << i << " " ;
        return dp[amount];
        
    }
};

int main() {
    Solution sol;
    std::vector<int> coins = {1, 2, 5};
    int res = sol.coinChange(coins, 11);
    std::cout << std::endl;
    std::cout << res << std::endl;
    return 0;
}

279. 完全平方数

题目分析

  • 创建了一个大小为n + 1的数组dp,所有元素初始化为INT32_MAX,这表示对于每个目标值来说,初始状态下所需的完全平方数数量是未知的,假定为无限大。
  • dp[0] = 0意味着和为0的数字最少需要0个完全平方数(即没有数字时的情况)。
  • 外循环遍历从1到n的所有数字,代表当前考虑的目标和。
  • 内循环尝试所有可能的完全平方数,即所有小于等于当前目标和i的完全平方数。
  • 对于每一个i和j,如果i大于或等于j的平方,那么dp[i](即组成和为i的最少完全平方数的数量)可以通过查看dp[i - j*j] + 1来更新。+1是因为j*j是当前考虑的一个完全平方数,而dp[i - j*j]则代表了减去这个完全平方数之后剩余部分的最优解。
  • 最终,dp[i]会被更新为所有可能的j中的最小值。

acm模式代码

cpp 复制代码
#include <iostream>
#include <vector>

class Solution {
public:
    int numSquares(int n) {
        std::vector<int> dp(n + 1, INT32_MAX);
        dp[0] = 0;

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j * j <= n; j ++) 
                if(i - j*j >= 0) dp[i] = std::min(dp[i - j*j] + 1, dp[i]);
        }

        for (int i: dp) {
            std::cout << i << " " ;
        }

        return dp[n];
    }
};

int main() {
    Solution sol;
    sol.numSquares(12);
    return 0;
}
相关推荐
海上小飞龙8 小时前
【KMP算法-下篇】同一道题:Java 库函数 2600 微秒,手写 KMP 16 微秒
java·开发语言·算法
青少儿编程课堂8 小时前
后缀自动机解析:本质不同子串与最长重复片段统计
c++·python·算法·bfs·信息学竞赛
朝朝辞暮i8 小时前
C++ 第 12 课:局部变量、作用域、变量生命周期
开发语言·c++·算法
乐迪信息9 小时前
港口船舶逆行怎么管?AI防爆摄像机搭载智能检测算法
大数据·人工智能·深度学习·算法·计算机视觉
Sirens.10 小时前
Java并发锁详解:六类锁策略与 synchronized 底层原理
java·前端·算法
和裕11 小时前
全纸结构重型纸箱能否满足 1 吨以上设备出口熏蒸豁免要求?通关合规性全解析
大数据·运维·网络·人工智能·算法
tangguofeng11 小时前
不带头结点的链队操作集(不含InitFlag)(C语言版)
算法
苏打豆12 小时前
CRISP源码阅读——基于ROS2力矩反馈控制器与速度加速度零空间
c++·线性代数·算法·矩阵·机器人
蛋蛋的就会顺顺的13 小时前
hot100——矩阵
java·数据结构·算法·leetcode·力扣
老歌老听老掉牙13 小时前
麻花钻切屑形态演变的力学机制与临界条件分析
python·算法·钻头